# Contributing

## Semantic Versioning

string-to-react-component follows semantic versioning. We release patch versions for critical bugfixes, minor versions for new features or non-essential changes, and major versions for any breaking changes.

## Proposing a Change

Patches for bugfixes are always welcome. Please accompany pull requests for bugfixes with a test case that is fixed by the PR. If you want to implement a new feature, It is advised to open an issue first in the GitHub.

## Before submitting a pull request, please make sure the following is done:

- Fork the repository and create your branch from main.
- If you’ve fixed a bug or added code that should be tested, add tests.
- Ensure the test suite passes : `$ npm run test`
- Format your code with prettier.
- Make sure you don't check-in any ESLint violations : `$ npm run lint`
- Update README with appropriate docs.
- Commit and PR
